]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
- this is not C
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
cd445739
AM
1#!/bin/sh
2# -----------
3# $Id$
4# Exit codes:
2a5f078d 5# 0 - succesful
6# 1 - help displayed
7# 2 - no spec file name in cmdl parameters
8# 3 - spec file not stored in repo
9# 4 - some source, patch or icon files not stored in repo
10# 5 - package build failed
11# 6 - spec file with errors
12# 7 - wrong source in /etc/poldek.conf
13# 8 - Failed installing buildrequirements and subrequirements
14# 9 - Requested tag already exist
15# 10 - Refused to build fractional release
16# 100 - Unknown error (should not happen)
cd445739
AM
17
18# Notes (todo):
f7b91886 19# - builder -u fetches current version first (well that's okay, how you compare versions if you have no old spec?)
cd445739 20# - when Icon: field is present, -5 and -a5 doesn't work
f3ada241 21# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
931a4acf 22
4003ad8c 23VERSION="\
c9acaed9 24Build package utility from PLD Linux CVS repository
0a302b4e 25v0.16 (C) 1999-2006 Free Penguins".
d6a77ddb 26PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 27
cd445739 28COMMAND="build"
64ea5308 29TARGET=""
cd445739 30
bde1c404 31SPECFILE=""
d287305c 32BE_VERBOSE=""
4003ad8c 33QUIET=""
cd445739
AM
34CLEAN=""
35DEBUG=""
36NOURLS=""
37NOCVS=""
38NOCVSSPEC=""
39NODIST=""
47761337 40NOINIT=""
cd445739 41UPDATE=""
cd445739
AM
42ADD5=""
43NO5=""
44ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
c8f50498 45CVSROOT=""
cd445739
AM
46
47# It can be used i.e. in log file naming.
48# See LOGFILE example.
49DATE=`date +%Y-%m-%d_%H-%M-%S`
50
51# Example: LOGFILE='../log.$PACKAGE_NAME'
52# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
53# Yes, you can use variable name! Note _single_ quotes!
54LOGFILE=''
55
56LOGDIR=""
57LOGDIROK=""
58LOGDIRFAIL=""
59LASTLOG_FILE=""
60
61CHMOD="no"
62CHMOD_MODE="0444"
63RPMOPTS=""
d1c5a9a7 64RPMBUILDOPTS=""
cd445739
AM
65BCOND=""
66GROUP_BCONDS="no"
947025e5 67CVSIGNORE_DF="no"
d287305c 68
69PATCHES=""
70SOURCES=""
cd445739 71ICONS=""
d287305c 72PACKAGE_RELEASE=""
73PACKAGE_VERSION=""
74PACKAGE_NAME=""
cd445739
AM
75PROTOCOL="ftp"
76WGET_RETRIES=${MAX_WGET_RETRIES:-0}
77CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
78
79CVSTAG=""
80RES_FILE=""
39dcc7de 81CVS_FORCE=""
cd445739
AM
82
83CVS_SERVER="cvs.pld-linux.org"
84DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 85ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 86
36d03934 87DEF_NICE_LEVEL=19
86aafdbe 88SCHEDTOOL="auto"
cd445739
AM
89
90FAIL_IF_NO_SOURCES="yes"
91
18e5347d
ER
92# let get_files skip over files which are present to get those damn files fetched
93SKIP_EXISTING_FILES="no"
94
975d7b23 95TRY_UPGRADE=""
257af81b
ER
96# should the specfile be restored if upgrade failed?
97REVERT_BROKEN_UPGRADE="yes"
98
ab4a2b6e 99if [ -x /usr/bin/rpm-getdeps ]; then
ce40491a 100 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
ab4a2b6e 101else
ce40491a 102 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
ab4a2b6e
ER
103fi
104
cd445739
AM
105# Here we load saved user environment used to
106# predefine options set above, or passed to builder
107# in command line.
108# This one reads global system environment settings:
109if [ -f ~/etc/builderrc ]; then
110 . ~/etc/builderrc
111fi
112# And this one cascades settings using user personal
113# builder settings.
114# Example of ~/.builderrc:
115#
116#UPDATE_POLDEK_INDEXES="yes"
117#FETCH_BUILD_REQUIRES="yes"
118#REMOVE_BUILD_REQUIRES="force"
119#GROUP_BCONDS="yes"
120#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
982e358c 121#TITLECHANGE=no
cd445739 122#
a83e5405 123SU_SUDO=""
cd445739
AM
124if [ -n "$HOME_ETC" ]; then
125 USER_CFG="$HOME_ETC/.builderrc"
126else
127 USER_CFG=~/.builderrc
128fi
129
130[ -f "$USER_CFG" ] && . "$USER_CFG"
131
86aafdbe
ER
132if [ "$SCHEDTOOL" = "auto" ]; then
133 if [ -x /usr/bin/schedtool ] && schedtool -B -e echo >/dev/null; then
134 SCHEDTOOL="schedtool -B -e"
135 else
136 SCHEDTOOL="no"
137 fi
138fi
139
ca2e6c31 140if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
141 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
142 GETURI2="$GETURI"
143 OUTFILEOPT="-O"
ca2e6c31 144elif [ -n "$USE_AXEL" ]; then
cede92b3 145 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
146 GETURI2="$GETURI"
147 OUTFILEOPT="-o"
ca2e6c31 148else
5700ee32
ER
149 wget --help 2>&1 | grep -q -- ' --no-check-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
150 wget --help 2>&1 | grep -q -- ' --inet ' && WGET_OPTS="$WGET_OPTS --inet"
151 wget --help 2>&1 | grep -q -- ' --retry-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
6f9a5d76 152
7e365483
KK
153 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
154 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
155 OUTFILEOPT="-O"
2bc5451f 156fi
11468b23 157
11468b23
AM
158GETLOCAL="cp -a"
159
160if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
161 RPM="rpm"
162 RPMBUILD="rpm"
163else
164 RPM="rpm"
165 RPMBUILD="rpmbuild"
166fi
167
168POLDEK_INDEX_DIR="`$RPM --eval %_rpmdir`/"
a83e5405 169POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 170
cd445739
AM
171run_poldek()
172{
173 RES_FILE=~/tmp/poldek-exit-status.$RANDOM
174 if [ -n "$LOGFILE" ]; then
175 LOG=`eval echo $LOGFILE`
176 if [ -n "$LASTLOG_FILE" ]; then
177 echo "LASTLOG=$LOG" > $LASTLOG_FILE
178 fi
86aafdbe 179 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
cd445739
AM
180 return $exit_pldk
181 else
86aafdbe 182 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
cd445739
AM
183 return `cat ${RES_FILE}`
184 rm -rf ${RES_FILE}
185 fi
186}
187
cd445739
AM
188#---------------------------------------------
189# functions
da946cd6 190
5a491465 191usage()
192{
cd445739
AM
193 if [ -n "$DEBUG" ]; then set -xv; fi
194 echo "\
195Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
cd445739 196[-bb|--build-binary] [-bs|--build-source] [-u|--try-upgrade]
39dcc7de
AG
197[{-cf|--cvs-force}] [{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>]
198[-g|--get] [-h|--help] [--http] [{-l,--logtofile} <logfile>] [-m|--mr-proper]
cd445739 199[-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T--tag <cvstag>]
a7b2951c 200[-Tvs|--tag-version-stable] [-Ts|--tag-stable] [-Tv|--tag-version]
cd445739 201[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}]
dfe2cb9a 202[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--show-bconds]
f19103b5 203[--with/--without <feature>] [--define <macro> <value>] <package>[.spec][:cvstag]
2a5f078d 204
cd445739
AM
205-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
206-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
207-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
208-D, --debug - enable builder script debugging mode,
209-debug - produce rpm debug package (same as --opts -debug)
cd445739
AM
210-V, --version - output builder version
211-a, --as_anon - get files via pserver as cvs@$CVS_SERVER,
212-b, -ba, --build - get all files from CVS repo or HTTP/FTP and build package
213 from <package>.spec,
214-bb, --build-binary - get all files from CVS repo or HTTP/FTP and build binary
215 only package from <package>.spec,
c56807e0
ER
216-bp, --build-prep - execute the %prep phase of <package>.spec,
217-bc - reserved (not implemented)
218-bi reserved (not implemented)
cd445739
AM
219-bs, --build-source - get all files from CVS repo or HTTP/FTP and only pack
220 them into src.rpm,
c56807e0 221--short-circuit - reserved (not implemented)
cd445739
AM
222-B, --branch - add branch
223-c, --clean - clean all temporarily created files (in BUILD, SOURCES,
224 SPECS and \$RPM_BUILD_ROOT),
39dcc7de 225-cf, --cvs-force - use -F when tagging (useful when moving branches)
2a5f078d 226-d <cvsroot>, --cvsroot <cvsroot>
cd445739
AM
227 - setup \$CVSROOT,
228--define <macro> <value>
229 - define a macro <macro> with value <value>,
230--nodeps - rpm won't check any dependences
231-g, --get - get <package>.spec and all related files from CVS repo
232 or HTTP/FTP,
233-h, --help - this message,
234--http - use http instead of ftp,
235-l <logfile>, --logtofile <logfile>
236 - log all to file,
237-m, --mr-proper - only remove all files related to spec file and all work
238 resources,
239-nc, --no-cvs - don't download sources from CVS, if source URL is given,
240-ncs, --no-cvs-specs
241 - don't check specs in CVS
242-nd, --no-distfiles - don't download from distfiles
243-nm, --no-mirrors - don't download from mirror, if source URL is given,
244-nu, --no-urls - don't try to download from FTP/HTTP location,
245-ns, --no-srcs - don't download Sources
246-ns0, --no-source0 - don't download Source0
247-nn, --no-net - don't download anything from the net
b572253e 248--no-init - don't initialize builder paths (SPECS and SOURCES)
18e5347d
ER
249-ske,
250--skip-existing-files - skip existing files in get_files
cd445739
AM
251--opts <rpm opts> - additional options for rpm
252-q, --quiet - be quiet,
253--date yyyy-mm-dd - build package using resources from specified CVS date,
254-r <cvstag>, --cvstag <cvstag>
255 - build package using resources from specified CVS tag,
5323fffd 256-A - build package using CVS resources as any sticky tags/date/kopts being reset.
cd445739
AM
257-R, --fetch-build-requires
258 - fetch what is BuildRequired,
259-RB, --remove-build-requires
260 - remove all you fetched with -R or --fetch-build-requires
261 remember, this option requires confirmation,
262-FRB, --force-remove-build-requires
263 - remove all you fetched with -R or --fetch-build-requires
264 remember, this option works without confirmation,
06541433
JR
265-sd, --source-distfiles - list sources available from distfiles (intended for offline
266 operations; does not work when Icon field is present
267 but icon file is absent),
268-sdp, --source-distfiles-paths - list sources available from distfiles -
269 paths relative to distfiles directory (intended for offline
270 operations; does not work when Icon field is present
271 but icon file is absent),
a7eefc54 272-sf, --source-files - list sources - bare filenames (intended for offline
273 operations; does not work when Icon field is present
3621e588 274 but icon file is absent),
a7eefc54 275-sp, --source-paths - list sources - filenames with full local paths (intended for
276 offline operations; does not work when Icon field is present
3621e588 277 but icon file is absent),
2dddf439
ER
278-su, --source-urls - list urls - urls to sources and patches
279 intended for copying urls with spec with lots of macros in urls
cd445739
AM
280-T <cvstag> , --tag <cvstag>
281 - add cvs tag <cvstag> for files,
282-Tvs, --tag-version-stable
094bd95b 283 - add cvs tags STABLE and NAME-VERSION-RELEASE for files,
cd445739
AM
284-Ts, --tag-stable
285 - add cvs tag STABLE for files,
cd445739 286-Tv, --tag-version
1691a37b 287 - add cvs tag NAME-VERSION-RELEASE for files,
cd445739
AM
288-Tp, --tag-prefix <prefix>
289 - add <prefix> to NAME-VERSION-RELEASE tags,
290-tt, --test-tag <prefix>
291 - fail if tag is already present,
50321881
JK
292-ir, --integer-release-only
293 - allow only integer and snapshot releases
cd445739
AM
294-v, --verbose - be verbose,
295-u, --try-upgrade - check version, and try to upgrade package
296-un, --try-upgrade-with-float-version
297 - as above, but allow float version
deccc50e 298-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
299-Upi, --update-poldek-indexes
300 - refresh or make poldek package index files.
c890b916 301-np, --nopatch <patchnumber>
bed98670 302 - don't apply <patchnumber>
dfe2cb9a
MK
303--show-bconds - show available conditional builds, which can be used
304 - with --with and/or --without switches.
cd445739
AM
305--with/--without <feature>
306 - conditional build package depending on %_with_<feature>/
307 %_without_<feature> macro switch. You may now use
308 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
309 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 310--target <platform>, --target=<platform>
3621e588
ER
311 - build for platform <platform>.
312--init-rpm-dir - initialize ~/rpm directory structure
5a491465 313"
314}
315
c890b916 316update_shell_title() {
a0d6396b 317 [ -t 1 ] || return
0b65d15e
ER
318 local len=${COLUMNS:-80}
319 local msg=$(echo "$*" | cut -c-$len)
320
e225de91
ER
321 if [ -n "$BE_VERBOSE" ]; then
322 echo >&2 "$(date +%s.%N) $*"
323 fi
324
982e358c 325 if [ "x$TITLECHANGE" == "xyes" -o "x$TITLECHANGE" == "x" ]; then
138bbc98
ER
326 local pkg
327 if [ -n "$PACKAGE_NAME" ]; then
328 pkg=${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_RELEASE}
329 else
330 pkg=${SPECFILE}
331 fi
332
333 msg="$pkg: ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
10c1e115 334 msg="$(echo $msg | tr -d '\n\r')"
982e358c
MP
335 case "$TERM" in
336 cygwin|xterm*)
337 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
338 ;;
339 screen*)
340 echo >&2 -ne "\033]0;$msg\007"
341 ;;
342 esac
343 fi
c890b916
ER
344}
345
7e40520f
ER
346# set TARGET from BuildArch: from SPECFILE
347set_spec_target() {
ce40491a
ER
348 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
349 tmp=$(awk '/^BuildArch:/ { print $NF}' $SPECFILE)
350 if [ "$tmp" ]; then
7e40520f
ER
351 TARGET="$tmp"
352 case "$RPMBUILD" in
353 "rpmbuild")
ce40491a 354 TARGET_SWITCH="--target $TARGET" ;;
7e40520f 355 "rpm")
ce40491a 356 TARGET_SWITCH="--target=$TARGET" ;;
7e40520f 357 esac
ce40491a
ER
358 fi
359 fi
7e40520f
ER
360}
361
cd445739 362cache_rpm_dump () {
d22150da 363 if [ -n "$DEBUG" ]; then
518ff1fb
ER
364 set -x
365 set -v
d22150da 366 fi
7e40520f 367
13974367 368 update_shell_title "cache_rpm_dump"
237bd3f1
ER
369 local rpm_dump
370 rpm_dump=`
d05e8080 371
fa4bf1df 372 # we reset macros not to contain macros.build as all the %() macros are
559d511f 373 # executed here, while none of them are actually needed.
fa4bf1df 374 # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
559d511f 375 # at the time of this writing macros.build + macros contained 70 "%(...)" macros.
36433112 376 macrofiles="/usr/lib/rpm/macros:$SPECS_DIR/.builder-rpmmacros:~/etc/.rpmmacros:~/.rpmmacros"
237bd3f1 377 dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
7cb24972 378 # FIXME: better ideas than .rpmrc?
36433112 379 printf 'include:/usr/lib/rpm/rpmrc\nmacrofiles:%s\n' $macrofiles > .builder-rpmrc
fb198857 380# TODO: move these to /usr/lib/rpm/macros
36433112 381 cat > .builder-rpmmacros <<'EOF'
fb198857
ER
382%requires_releq_kernel_up %{nil}
383%requires_releq_kernel_smp %{nil}
6b8134e3 384%requires_releq() %{nil}
bb01dee9 385%pyrequires_eq() %{nil}
559d511f 386%requires_eq() %{nil}
c13be3d1 387%requires_eq_to() %{nil}
fb198857
ER
388%releq_kernel_up ERROR
389%releq_kernel_smp ERROR
74d9fd14 390%kgcc_package ERROR
237bd3f1 391%_fontsdir ERROR
7141278d 392%ruby_version ERROR
393%ruby_ver_requires_eq() %{nil}
394%ruby_mod_ver_requires_eq() %{nil}
c13be3d1 395%__php_api_requires() %{nil}
7141278d 396%php_major_version ERROR
397%php_api_version ERROR
398%py_ver ERROR
41035426
ER
399%perl_vendorarch ERROR
400%perl_vendorlib ERROR
fb198857 401EOF
cd445739 402 case "$RPMBUILD" in
237bd3f1
ER
403 rpm)
404 ARGS='-bp'
405 ;;
406 rpmbuild)
407 ARGS='--nodigest --nosignature --nobuild'
408 ;;
409 esac
3d12d055
JR
410 if [ "$NOINIT" = "yes" ] ; then
411 cat >> .builder-rpmmacros <<'EOF'
412%_specdir ./
413%_sourcedir ./
414EOF
c039643c
JR
415 fi
416 $RPMBUILD --rcfile .builder-rpmrc $ARGS $ARGDIRS --nodeps --define "prep $dump" $BCOND $TARGET_SWITCH $SPECFILE 2>&1
237bd3f1 417 `
fb198857 418 if [ $? -gt 0 ]; then
237bd3f1
ER
419 error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
420 echo "$error" >&2
518ff1fb 421 Exit_error err_build_fail
fb198857 422 fi
d05e8080
ER
423
424 # make small dump cache
425 rpm_dump_cache=`echo "$rpm_dump" | awk '
4e8c3089
ER
426 $2 ~ /^SOURCEURL/ {print}
427 $2 ~ /^PATCHURL/ {print}
428 $2 ~ /^nosource/ {print}
429 $2 ~ /^PACKAGE_/ {print}
d05e8080
ER
430 '`
431
13974367 432 update_shell_title "cache_rpm_dump: OK!"
cd445739
AM
433}
434
435rpm_dump () {
436 if [ -z "$rpm_dump_cache" ] ; then
d7b4d36e 437 echo "internal error: cache_rpm_dump not called! (missing %prep?)" 1>&2
cd445739
AM
438 fi
439 echo "$rpm_dump_cache"
440}
441
d05e8080
ER
442get_icons()
443{
444 update_shell_title "get icons"
445 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
446 if [ -z "$ICONS" ]; then
447 return
448 fi
449
975d7b23 450 rpm_dump_cache="kalasaba" NODIST="yes" get_files $ICONS
d05e8080
ER
451}
452
59398507 453parse_spec()
454{
af4d5315 455 update_shell_title "parsing specfile"
cd445739 456 if [ -n "$DEBUG" ]; then
518ff1fb
ER
457 set -x
458 set -v
cd445739 459 fi
b2975fc3 460
d05e8080 461 # icons are needed for successful spec parse
518ff1fb 462 get_icons
d05e8080 463
cd445739 464 cd $SPECS_DIR
cd445739 465 cache_rpm_dump
00fcec7e 466
cd445739
AM
467 if [ "$NOSRCS" != "yes" ]; then
468 SOURCES="`rpm_dump | awk '/SOURCEURL[0-9]+/ {print $3}'`"
469 fi
7cb24972 470
cd445739
AM
471 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
472 FAIL_IF_NO_SOURCES="no"
473 fi
474
475 PATCHES="`rpm_dump | awk '/PATCHURL[0-9]+/ {print $3}'`"
476 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
fa4bf1df
ER
477 PACKAGE_NAME=$(rpm_dump | awk '$2 == "PACKAGE_NAME" { print $3}')
478 PACKAGE_VERSION=$(rpm_dump | awk '$2 == "PACKAGE_VERSION" { print $3}')
479 PACKAGE_RELEASE=$(rpm_dump | awk '$2 == "PACKAGE_RELEASE" { print $3}')
78eab2a1 480
cd445739
AM
481 if [ -n "$BE_VERBOSE" ]; then
482 echo "- Sources : `nourl $SOURCES`"
483 if [ -n "$PATCHES" ]; then
484 echo "- Patches : `nourl $PATCHES`"
485 else
486 echo "- Patches : *no patches needed*"
487 fi
488 if [ -n "$ICONS" ]; then
489 echo "- Icon : `nourl $ICONS`"
490 else
491 echo "- Icon : *no package icon*"
492 fi
493 echo "- Name : $PACKAGE_NAME"
494 echo "- Version : $PACKAGE_VERSION"
495 echo "- Release : $PACKAGE_RELEASE"
496 fi
13974367
ER
497
498 update_shell_title "parse_spec: OK!"
cd445739
AM
499}
500
501Exit_error()
502{
503 if [ -n "$DEBUG" ]; then
518ff1fb
ER
504 set -x
505 set -v
cd445739
AM
506 fi
507
508 cd "$__PWD"
509
510 case "$1" in
511 "err_no_spec_in_cmdl" )
512 remove_build_requires
518ff1fb 513 echo "ERROR: spec file name not specified."
cd445739
AM
514 exit 2 ;;
515 "err_no_spec_in_repo" )
516 remove_build_requires
518ff1fb 517 echo "Error: spec file not stored in CVS repo."
cd445739
AM
518 exit 3 ;;
519 "err_no_source_in_repo" )
520 remove_build_requires
518ff1fb 521 echo "Error: some source, patch or icon files not stored in CVS repo. ($2)"
cd445739
AM
522 exit 4 ;;
523 "err_build_fail" )
524 remove_build_requires
518ff1fb 525 echo "Error: package build failed. (${2:-no more info})"
cd445739 526 exit 5 ;;
78eab2a1
AM
527 "err_no_package_data" )
528 remove_build_requires
529 echo "Error: couldn't get out package name/version/release from spec file."
530 exit 6 ;;
ce40491a 531 "err_tag_exists" )
50321881 532 remove_build_requires
518ff1fb 533 echo "Tag ${2} already exists (spec release: ${3})."
50321881 534 exit 9 ;;
ce40491a 535 "err_fract_rel" )
50321881 536 remove_build_requires
518ff1fb 537 echo "Release ${2} not integer and not a snapshot."
50321881 538 exit 10 ;;
fb96e0b5
AM
539 "err_branch_exists" )
540 remove_build_requires
518ff1fb 541 echo "Tree branch already exists (${2})."
fb96e0b5 542 exit 11 ;;
50321881 543
cd445739 544 esac
73848362
ER
545 echo "Unknown error."
546 exit 100
cd445739
AM
547}
548
549init_builder()
550{
551 if [ -n "$DEBUG" ]; then
518ff1fb
ER
552 set -x
553 set -v
0dd6320d 554 fi
cd445739 555
4aeb9973 556 if [ "$NOINIT" != "yes" ] ; then
29e90b02
JR
557 SOURCE_DIR="`eval $RPM $RPMOPTS --eval '%{_sourcedir}'`"
558 SPECS_DIR="`eval $RPM $RPMOPTS --eval '%{_specdir}'`"
559 else
560 SOURCE_DIR="."
561 SPECS_DIR="."
562 fi
cd445739
AM
563
564 __PWD="`pwd`"
00fcec7e 565}
566
d6a77ddb 567get_spec()
1471f6d6 568{
c890b916 569
2e5be021 570 update_shell_title "get_spec"
c890b916 571
cd445739 572 if [ -n "$DEBUG" ]; then
518ff1fb
ER
573 set -x
574 set -v
cd445739
AM
575 fi
576
577 cd "$SPECS_DIR"
049ab214 578 if [ ! -f "$SPECFILE" ]; then
518ff1fb 579 SPECFILE="`basename $SPECFILE .spec`.spec"
cd445739
AM
580 fi
581 if [ "$NOCVSSPEC" != "yes" ]; then
cd445739 582
049ab214
ER
583 if [ ! -s CVS/Root -a "$NOCVSSPEC" != "yes" ]; then
584 echo "Warning: No CVS access defined - using local .spec file"
585 NOCVSSPEC="yes"
cd445739
AM
586 fi
587
049ab214 588 cvsup "$SPECFILE" || Exit_error err_no_spec_in_repo
cd445739 589 fi
049ab214 590
cd445739 591 if [ ! -f "$SPECFILE" ]; then
518ff1fb 592 Exit_error err_no_spec_in_repo
cd445739
AM
593 fi
594
595 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
596 chmod $CHMOD_MODE $SPECFILE
597 fi
598 unset OPTIONS
a7eefc54 599 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $SPECFILE
7e40520f 600
ce40491a 601 set_spec_target
cd445739
AM
602}
603
604find_mirror()
605{
606 cd "$SPECS_DIR"
782518da 607 local url="$1"
cd445739
AM
608 if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
609 cvs update mirrors >&2
610 fi
611
612 IFS="|"
782518da
ER
613 local origin mirror name rest ol prefix
614 while read origin mirror name rest; do
615 # skip comments and empty lines
616 if [ -z "$origin" ] || [[ $origin == \#* ]]; then
617 continue
618 fi
cd445739
AM
619 ol=`echo -n "$origin"|wc -c`
620 prefix="`echo -n "$url" | head -c $ol`"
621 if [ "$prefix" = "$origin" ] ; then
782518da 622 suffix="`echo "$url"|cut -b $((ol+1))-`"
cd445739
AM
623 echo -n "$mirror$suffix"
624 return 0
625 fi
626 done < mirrors
627 echo "$url"
628}
629
e7e0d4ec 630# Warning: unpredictable results if same URL used twice
cd445739
AM
631src_no ()
632{
633 cd $SPECS_DIR
634 rpm_dump | \
635 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
636 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
637 head -n 1 | xargs
1471f6d6 638}
639
e7e0d4ec 640src_md5()
8ba5cdda 641{
e7e0d4ec 642 [ "$NO5" = "yes" ] && return
cd445739
AM
643 no=$(src_no "$1")
644 [ -z "$no" ] && return
645 cd $SPECS_DIR
e7e0d4ec
ER
646 local md5
647
648 if [ -f additional-md5sums ]; then
649 local spec_rev=$(grep $SPECFILE CVS/Entries 2>/dev/null | sed -e s:/$SPECFILE/:: -e s:/.*::)
650 if [ -z "$spec_rev" ]; then
651 spec_rev="$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')"
652 fi
653 local spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
654 md5=$(grep -s -v '^#' additional-md5sums | \
655 grep -E "[ ]$(basename "$1")[ ]+${spec}([ ,]|\$)" | \
656 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
657 grep -E '^[0-9a-f]{32}$')
658
659 if [ "$md5" ]; then
660 if [ $(echo "$md5" | wc -l) != 1 ] ; then
661 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
662 fi
663 echo "$md5" | tail -n 1
664 return
665 fi
cd445739 666 fi
e7e0d4ec
ER
667
668 source_md5=`grep -i "#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
669 if [ -n "$source_md5" ]; then
670 echo $source_md5
cd445739 671 else
e7e0d4ec
ER
672 # we have empty SourceX-md5, but it is still possible
673 # that we have NoSourceX-md5 AND NoSource: X
674 nosource_md5=`grep -i "#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
03db3356 675 if [ -n "$nosource_md5" -a -n "`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" ] ; then
e7e0d4ec 676 echo $nosource_md5
cd445739 677 fi
cd445739
AM
678 fi
679}
680
06541433
JR
681distfiles_path ()
682{
683 echo "by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
684}
685
cd445739
AM
686distfiles_url ()
687{
06541433 688 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/$(distfiles_path "$1")"
cd445739
AM
689}
690
691distfiles_attic_url ()
692{
06541433 693 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/$(distfiles_path "$1")"
cd445739
AM
694}
695
696good_md5 ()
697{
698 md5=$(src_md5 "$1")
699 [ "$md5" = "" ] || \
700 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
701}
702
a4b50627
AF
703good_size ()
704{
ce40491a
ER
705 size="$(find $(nourl "$1") -printf "%s" 2>/dev/null)"
706 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
707}
708
947025e5 709cvsignore_df ()
710{
711 if [ "$CVSIGNORE_DF" != "yes" ]; then
712 return
713 fi
714 cvsignore=${SOURCE_DIR}/.cvsignore
715 if ! grep -q "^$1\$" $cvsignore 2> /dev/null; then
716 echo "$1" >> $cvsignore
717 fi
718}
719
e7fa3b9f
ER
720cvsup()
721{
ce40491a
ER
722 update_shell_title "cvsup"
723 local OPTIONS="up "
724 if [ -n "$CVSROOT" ]; then
725 OPTIONS="-d $CVSROOT $OPTIONS"
726 fi
b1c6aace 727
ce40491a
ER
728 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
729 OPTIONS="$OPTIONS -A"
730 else
731 if [ -n "$CVSDATE" ]; then
732 OPTIONS="$OPTIONS -D $CVSDATE"
733 fi
734 if [ -n "$CVSTAG" ]; then
735 OPTIONS="$OPTIONS -r $CVSTAG"
736 fi
737 fi
e7fa3b9f 738
ce40491a
ER
739 local result=1
740 local retries_counter=0
741 if [ $# = 1 ]; then
742 update_shell_title "cvsup: $*"
743 else
744 update_shell_title "cvsup: $# files"
745 fi
746 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; do
747 retries_counter=$(( $retries_counter + 1 ))
748 output=$(LC_ALL=C cvs $OPTIONS "$@" 2>&1)
749 result=$?
750 [ -n "$output" ] && echo "$output"
751 if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
752 echo "Trying again [$*]... ($retries_counter)"
753 update_shell_title "cvsup: retry #$retries_counter"
754 sleep 2
755 continue
756 else
757 break
758 fi
759 done
760 update_shell_title "cvsup: done!"
761 return $result
e7fa3b9f
ER
762}
763
71f8e908
ER
764# returns true if "$1" is ftp, http or https protocol url
765is_url()
766{
767 case "$1" in
768 ftp://*|http://*|https://*)
769 return 0
770 ;;
771 esac
772 return 1
773}
774
ecba6ad5
ER
775update_md5()
776{
777 if [ $# -eq 0 ]; then
778 return
779 fi
780
781 update_shell_title "update md5"
782 if [ -n "$DEBUG" ]; then
518ff1fb
ER
783 set -x
784 set -v
ecba6ad5
ER
785 fi
786
787 cd "$SOURCE_DIR"
788
789 # pass 1: check files to be fetched
790 local todo
791 local need_files
792 for i in "$@"; do
793 local fp=$(nourl "$i")
794 local srcno=$(src_no "$i")
6392b5fd
ER
795 if [ -n "$ADD5" ]; then
796 [ "$fp" = "$i" ] && continue # FIXME what is this check doing?
797 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE && continue
798 else
799 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE || continue
ecba6ad5
ER
800 fi
801 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
802 need_files="$need_files $i"
803 fi
804 done
805
806 # pass 1a: get needed files
807 if [ "$need_files" ]; then
808 get_files $need_files
809 fi
810
811 # pass 2: proceed with md5 adding or updating
812 for i in "$@"; do
813 local fp=$(nourl "$i")
814 local srcno=$(src_no "$i")
71f8e908
ER
815 local md5=$(grep -iE '^#[ ]*(No)?Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE )
816 if [ -n "$ADD5" ] && is_url $i || [ -n "$md5" ]; then
817 local tag="Source$srcno-md5"
818 if [[ "$md5" == *NoSource* ]]; then
819 tag="NoSource$srcno-md5"
820 fi
ecba6ad5 821 md5=$(md5sum "$fp" | cut -f1 -d' ')
71f8e908 822 echo "Updating $tag ($md5)."
ecba6ad5 823 perl -i -ne '
71f8e908
ER
824 print unless /^\s*#\s*(No)?Source'$srcno'-md5\s*:/i;
825 print "# '$tag':\t'$md5'\n" if /^Source'$srcno'\s*:\s+/;
ecba6ad5
ER
826 ' \
827 $SPECS_DIR/$SPECFILE
828 fi
829 done
830}
831
832check_md5()
833{
834 update_shell_title "check md5"
835
836 for i in "$@"; do
837 if good_md5 "$i" && good_size "$i"; then
838 continue
839 fi
840
841 echo "MD5 sum mismatch or 0 size. Use -U to refetch sources,"
842 echo "or -5 to update md5 sums, if you're sure files are correct."
843 Exit_error err_no_source_in_repo $i
844 done
845}
846
cd445739
AM
847get_files()
848{
7cb24972 849 update_shell_title "get_files"
cd445739
AM
850
851 if [ -n "$DEBUG" ]; then
518ff1fb
ER
852 set -x
853 set -v
cd445739
AM
854 fi
855
f09c0772 856 if [ $# -gt 0 ]; then
cd445739
AM
857 cd "$SOURCE_DIR"
858
b1c6aace 859 if [ ! -s CVS/Root -a "$NOCVS" != "yes" ]; then
049ab214 860 echo "Warning: No CVS access defined for SOURCES"
b1c6aace
ER
861 NOCVS="yes"
862 fi
863
f2e42a41 864 local nc=0
e7fa3b9f 865 local get_files_cvs=""
3815b69a 866 for i in "$@"; do
f2e42a41 867 nc=$((nc + 1))
dcebdffb 868 local cvsup=0
3815b69a 869 SHELL_TITLE_PREFIX="get_files[$nc/$#]"
f2e42a41 870 update_shell_title "$i"
f09c0772 871 local fp=`nourl "$i"`
ecba6ad5 872 if [ "$SKIP_EXISTING_FILES" = "yes" ] && [ -f "$fp" ]; then
ce40491a 873 continue
18e5347d 874 fi
ecba6ad5 875
cd445739 876 FROM_DISTFILES=0
e7e0d4ec 877 local srcmd5=$(src_md5 "$i")
ecba6ad5
ER
878
879 # we know if source/patch is present in cvs/distfiles
880 # - has md5 (in distfiles)
881 # - in cvs... ideas?
882
883 # CHECK: local file didn't exist or always cvs up (first) requested.
f09c0772 884 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
cd445739
AM
885 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
886 echo "Warning: no URL given for $i"
887 fi
888
e7e0d4ec 889 if [ -z "$NODIST" ] && [ -n "$srcmd5" ]; then
a4b50627 890 if good_md5 "$i" && good_size "$i"; then
e7e0d4ec 891 echo "$fp having proper md5sum already exists"
cd445739
AM
892 continue
893 fi
4ea1c265 894 target="$fp"
cd445739
AM
895 url=$(distfiles_url "$i")
896 url_attic=$(distfiles_attic_url "$i")
897 FROM_DISTFILES=1
ecba6ad5
ER
898 # is $url local file?
899 if [[ "$url" = [./]* ]]; then
18a52930 900 update_shell_title "${GETLOCAL%% *}: $url"
cd445739
AM
901 ${GETLOCAL} $url $target
902 else
903 if [ -z "$NOMIRRORS" ]; then
904 url="`find_mirror "$url"`"
905 fi
18a52930 906 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 907 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 908 if [ "`echo $url | grep -E 'ftp://'`" ]; then
18a52930 909 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 910 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
911 fi
912 fi
ecba6ad5
ER
913
914 # is it empty file?
915 if [ ! -s "$target" ]; then
cd445739
AM
916 rm -f "$target"
917 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
18a52930 918 update_shell_title "${GETLOCAL%% *}: $url_attic"
cd445739
AM
919 ${GETLOCAL} $url_attic $target
920 else
921 if [ -z "$NOMIRRORS" ]; then
922 url_attic="`find_mirror "$url_attic"`"
923 fi
18a52930 924 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 925 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 926 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 927 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 928 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
929 fi
930 fi
931 fi
ecba6ad5
ER
932
933 if [ -s "$target" ]; then
947025e5 934 cvsignore_df $target
935 else
cd445739
AM
936 rm -f "$target"
937 FROM_DISTFILES=0
938 fi
e7e0d4ec 939 elif [ "$NOCVS" != "yes" -a -z "$srcmd5" ]; then
d05e8080
ER
940 if [ $# -gt 1 ]; then
941 get_files_cvs="$get_files_cvs $fp"
942 update_shell_title "$fp (will cvs up later)"
943 cvsup=1
944 else
945 cvsup $fp
946 fi
cd445739
AM
947 fi
948
f09c0772 949 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739
AM
950 if [ -z "$NOMIRRORS" ]; then
951 im="`find_mirror "$i"`"
952 else
953 im="$i"
954 fi
ce40491a 955 update_shell_title "${GETURI%% *}: $im"
cd445739 956 ${GETURI} "$im" || \
33da77c4 957 if [ "`echo $im | grep -E 'ftp://'`" ]; then
ce40491a 958 update_shell_title "${GETURI2%% *}: $im"
cd445739 959 ${GETURI2} "$im"
7e365483 960 fi
cd445739
AM
961 fi
962
dcebdffb
ER
963 if [ "$cvsup" = 1 ]; then
964 continue
965 fi
966
cd445739 967 fi
ecba6ad5
ER
968
969 # the md5 check must be moved elsewhere as if we've called from update_md5 the md5 is wrong.
f09c0772 970 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
518ff1fb 971 Exit_error err_no_source_in_repo $i
cd445739 972 fi
2a5f078d 973
ecba6ad5 974 # we check md5 here just only to refetch immediately
a4b50627 975 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
976 :
977 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 978 # wrong md5 from distfiles: remove the file and try again
cd445739 979 # but only once ...
deccc50e 980 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
981 FROM_DISTFILES=2
982 rm -f $target
18a52930 983 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 984 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 985 if [ "`echo $url | grep -E 'ftp://'`" ]; then
ce40491a 986 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 987 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739 988 fi
ecba6ad5 989 if [ ! -s "$target" ]; then
cd445739 990 rm -f "$target"
18a52930 991 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 992 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 993 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 994 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 995 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
996 fi
997 fi
998 test -s "$target" || rm -f "$target"
999 fi
cd445739 1000 done
e7fa3b9f
ER
1001 SHELL_TITLE_PREFIX=""
1002
1003 if [ "$get_files_cvs" ]; then
ce40491a 1004 cvsup $get_files_cvs
e7fa3b9f 1005 fi
cd445739
AM
1006
1007 if [ "$CHMOD" = "yes" ]; then
3815b69a 1008 CHMOD_FILES="`nourl "$@"`"
cd445739
AM
1009 if [ -n "$CHMOD_FILES" ]; then
1010 chmod $CHMOD_MODE $CHMOD_FILES
1011 fi
1012 fi
cd445739
AM
1013 fi
1014}
1015
1016make_tagver() {
ce40491a 1017 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1018 set -x
1019 set -v
ce40491a 1020 fi
78eab2a1 1021
ce40491a
ER
1022 # Check whether first character of PACKAGE_NAME is legal for tag name
1023 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
1024 TAG_PREFIX=tag_
1025 fi
1026 TAGVER=$TAG_PREFIX$PACKAGE_NAME-`echo $PACKAGE_VERSION | sed -e "s/\./\_/g" -e "s/@/#/g"`-`echo $PACKAGE_RELEASE | sed -e "s/\./\_/g" -e "s/@/#/g"`
1027 # Remove #kernel.version_release from TAGVER because tagging sources
1028 # could occur with different kernel-headers than kernel-headers used at build time.
1029 TAGVER=$(echo "$TAGVER" | sed -e 's/#.*//g')
1030 echo -n "$TAGVER"
cd445739
AM
1031}
1032
1033tag_files()
1034{
1035 TAG_FILES="$@"
1036
1037 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1038 set -x
1039 set -v
cd445739
AM
1040 fi
1041
73ef63d8
ER
1042 echo "Version: $PACKAGE_VERSION"
1043 echo "Release: $PACKAGE_RELEASE"
cd445739 1044
73ef63d8 1045 TAGVER=`make_tagver`
cd445739 1046
73ef63d8
ER
1047 if [ "$TAG_VERSION" = "yes" ]; then
1048 echo "CVS tag: $TAGVER"
1049 fi
1050 if [ -n "$TAG" ]; then
1051 echo "CVS tag: $TAG"
1052 fi
cd445739 1053
39dcc7de 1054 local OPTIONS="tag $CVS_FORCE"
73ef63d8
ER
1055 if [ -n "$CVSROOT" ]; then
1056 OPTIONS="-d $CVSROOT $OPTIONS"
1057 fi
cd445739 1058
73ef63d8
ER
1059 cd "$SOURCE_DIR"
1060 local tag_files
1061 for i in $TAG_FILES; do
1062 # don't tag files stored on distfiles
1063 [ -n "`src_md5 $i`" ] && continue
1064 local fp=`nourl "$i"`
1065 if [ -f "$fp" ]; then
1066 tag_files="$tag_files $fp"
1067 else
1068 Exit_error err_no_source_in_repo $i
03db3356 1069 fi
73ef63d8 1070 done
03db3356 1071
73ef63d8 1072 if [ "$tag_files" ]; then
cd445739 1073 if [ "$TAG_VERSION" = "yes" ]; then
73ef63d8
ER
1074 update_shell_title "tag sources: $TAGVER"
1075 cvs $OPTIONS $TAGVER $tag_files
cd445739
AM
1076 fi
1077 if [ -n "$TAG" ]; then
73ef63d8
ER
1078 update_shell_title "tag sources: $TAG"
1079 cvs $OPTIONS $TAG $tag_files
cd445739 1080 fi
73ef63d8
ER
1081 fi
1082
1083 cd "$SPECS_DIR"
1084 if [ "$TAG_VERSION" = "yes" ]; then
1085 update_shell_title "tag spec: $TAGVER"
1086 cvs $OPTIONS $TAGVER $SPECFILE
1087 fi
1088 if [ -n "$TAG" ]; then
1089 update_shell_title "tag spec: $TAG"
1090 cvs $OPTIONS $TAG $SPECFILE
1091 fi
cd445739
AM
1092}
1093
1094branch_files()
1095{
1096 TAG=$1
1097 echo "CVS branch tag: $TAG"
518ff1fb 1098 shift
cd445739
AM
1099
1100 TAG_FILES="$@"
1101
1102 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1103 set -x
1104 set -v
cd445739
AM
1105 fi
1106
78a5a506
ER
1107 local OPTIONS="tag $CVS_FORCE -b"
1108 if [ -n "$CVSROOT" ]; then
1109 OPTIONS="-d $CVSROOT $OPTIONS"
1110 fi
1111 cd "$SOURCE_DIR"
1112 local tag_files
1113 for i in $TAG_FILES; do
1114 local fp=`nourl "$i"`
1115 if [ -f "$fp" ]; then
1116 tag_files="$tag_files $fp"
1117 else
1118 Exit_error err_no_source_in_repo $i
c10fa4fa 1119 fi
78a5a506
ER
1120 done
1121 if [ "$tag_files" ]; then
1122 cvs $OPTIONS $TAG $tag_files
1123 fi
c10fa4fa 1124
78a5a506
ER
1125 cd "$SPECS_DIR"
1126 cvs $OPTIONS $TAG $SPECFILE
cd445739
AM
1127}
1128
1129
1130
59398507 1131build_package()
1132{
2e5be021 1133 update_shell_title "build_package"
cd445739 1134 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1135 set -x
1136 set -v
cd445739 1137 fi
5a491465 1138
cd445739
AM
1139 cd "$SPECS_DIR"
1140
1141 if [ -n "$TRY_UPGRADE" ]; then
ce40491a 1142 update_shell_title "build_package: try_upgrade"
cd445739 1143 if [ -n "$FLOAT_VERSION" ]; then
cc538c24 1144 TNOTIFY=`./pldnotify.awk $SPECFILE -n` || exit 1
cd445739 1145 else
cc538c24 1146 TNOTIFY=`./pldnotify.awk $SPECFILE` || exit 1
cd445739
AM
1147 fi
1148
1149 TNEWVER=`echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }'`
1150
1151 if [ -n "$TNEWVER" ]; then
1152 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
1153 echo "New version found, updating spec file to version " $TNEWVER
257af81b
ER
1154 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1155 cp -f $SPECFILE $SPECFILE.bak
1156 fi
cd445739
AM
1157 chmod +w $SPECFILE
1158 eval "perl -pi -e 's/Version:\t"$TOLDVER"/Version:\t"$TNEWVER"/gs' $SPECFILE"
f7b91886 1159 eval "perl -pi -e 's/Release:\t[1-9]{0,4}/Release:\t0.1/' $SPECFILE"
518ff1fb
ER
1160 parse_spec
1161 NODIST="yes" get_files $SOURCES $PATCHES
6392b5fd 1162 update_md5 $SOURCES
975d7b23 1163
cd445739
AM
1164 unset TOLDVER TNEWVER TNOTIFY
1165 fi
1166 fi
1167 cd "$SPECS_DIR"
2a5f078d 1168
cd445739
AM
1169 case "$COMMAND" in
1170 build )
1171 BUILD_SWITCH="-ba" ;;
1172 build-binary )
1173 BUILD_SWITCH="-bb" ;;
1174 build-source )
1175 BUILD_SWITCH="-bs --nodeps" ;;
1176 build-prep )
1177 BUILD_SWITCH="-bp --nodeps" ;;
1178 esac
c890b916 1179
2e5be021 1180 update_shell_title "build_package: $COMMAND"
cd445739
AM
1181 if [ -n "$LOGFILE" ]; then
1182 LOG=`eval echo $LOGFILE`
1183 if [ -d "$LOG" ]; then
1184 echo "Log file $LOG is a directory."
1185 echo "Parse error in the spec?"
518ff1fb 1186 Exit_error err_build_fail
cd445739
AM
1187 fi
1188 if [ -n "$LASTLOG_FILE" ]; then
1189 echo "LASTLOG=$LOG" > $LASTLOG_FILE
1190 fi
1191 RES_FILE=~/tmp/$RPMBUILD-exit-status.$RANDOM
86aafdbe 1192 (time eval ${NICE_COMMAND} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
cd445739
AM
1193 RETVAL=`cat $RES_FILE`
1194 rm $RES_FILE
1195 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
1196 if [ "$RETVAL" -eq "0" ]; then
1197 mv $LOG $LOGDIROK
1198 else
1199 mv $LOG $LOGDIRFAIL
1200 fi
1201 fi
8ba5cdda 1202 else
86aafdbe 1203 eval ${NICE_COMMAND} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $SPECFILE
cd445739 1204 RETVAL=$?
8ba5cdda 1205 fi
cd445739
AM
1206 if [ "$RETVAL" -ne "0" ]; then
1207 if [ -n "$TRY_UPGRADE" ]; then
796a8a95 1208 echo "\n!!! Package with new version cannot be built automagically\n"
257af81b
ER
1209 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1210 mv -f $SPECFILE.bak $SPECFILE
1211 fi
cd445739 1212 fi
518ff1fb 1213 Exit_error err_build_fail
cd445739
AM
1214 fi
1215 unset BUILD_SWITCH
1216}
1217
1218nourl()
1219{
1220 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1221}
1222
cd445739
AM
1223install_required_packages()
1224{
1225 run_poldek -vi $1
1226 return $?
1227}
1228
fa4bf1df
ER
1229find_spec_bcond() {
1230 # taken from find-spec-bcond, but with just getting the list
1231 local SPEC="$1"
1232 # quick revert hint: '$RPMBUILD --bcond $SPEC'
1233 awk -F"\n" '
1234 /^%changelog/ { exit }
1235 /_with(out)?_[_a-zA-Z0-9]+/{
1236 match($0, /_with(out)?_[_a-zA-Z0-9]+/);
1237 print substr($0, RSTART, RLENGTH);
1238 }
1239 /^%bcond_with/{
1240 match($0, /bcond_with(out)?[ \t]+[_a-zA-Z0-9]+/);
1241 bcond = substr($0, RSTART +5 , RLENGTH -5);
1242 gsub(/[ \t]+/,"_",bcond);
1243 print bcond
1244 }' $SPEC | LC_ALL=C sort -u
1245}
1246
cd445739
AM
1247set_bconds_values()
1248{
0b65d15e 1249 update_shell_title "set bcond values"
c890b916 1250
cd445739
AM
1251 AVAIL_BCONDS_WITHOUT=""
1252 AVAIL_BCONDS_WITH=""
1253 if `grep -q ^%bcond ${SPECFILE}`; then
1254 BCOND_VERSION="NEW"
36d03934 1255 elif `egrep -q ^#\ *_with ${SPECFILE}`; then
cd445739
AM
1256 BCOND_VERSION="OLD"
1257 else
fa4bf1df 1258 return
cd445739 1259 fi
301cbfd4 1260
fa4bf1df
ER
1261 local bcond_avail=$(find_spec_bcond $SPECFILE)
1262
301cbfd4
ER
1263 # expand bconds from ~/.bcondrc
1264 # The file structure is like gentoo's package.use:
1265 # ---
1266 # * -selinux
1267 # samba -mysql -pgsql
47a8df12 1268 # w32codec-installer license_agreement
301cbfd4
ER
1269 # php +mysqli
1270 # ---
fa4bf1df 1271 if ([ -f $HOME/.bcondrc ] || ([ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ])); then
3e1cbfe0 1272 SN=${SPECFILE%%\.spec}
301cbfd4 1273
fa4bf1df
ER
1274 local bcondrc=$HOME/.bcondrc
1275 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && bcondrc=$HOME_ETC/.bcondrc
c8a3e2ac 1276
301cbfd4
ER
1277 while read pkg flags; do
1278 # ignore comments
1279 [[ "$pkg" == \#* ]] && continue
1280
1281 # any package or current package?
fa4bf1df 1282 if [ "$pkg" = "*" ] || [ "$pkg" = "$PACKAGE_NAME" ] || [ "$pkg" = "$SN" ]; then
301cbfd4 1283 for flag in $flags; do
fa4bf1df 1284 local opt=${flag#[+-]}
301cbfd4
ER
1285
1286 # use only flags which are in this package.
fa4bf1df 1287 if [[ $bcond_avail = *${opt}* ]]; then
3b5101f0 1288 if [[ $flag = -* ]]; then
3f73a917 1289 if [[ $BCOND != *--with?${opt}* ]]; then
1290 BCOND="$BCOND --without $opt"
1291 fi
301cbfd4 1292 else
3f73a917 1293 if [[ $BCOND != *--without?${opt}* ]]; then
1294 BCOND="$BCOND --with $opt"
1295 fi
301cbfd4
ER
1296 fi
1297 fi
1298 done
1299 fi
fa4bf1df
ER
1300 done < $bcondrc
1301 update_shell_title "parse ~/.bcondrc: DONE!"
301cbfd4
ER
1302 fi
1303
fa4bf1df 1304 update_shell_title "parse bconds"
cd445739 1305 case "${BCOND_VERSION}" in
fa4bf1df 1306 NONE)
7e365483 1307 :
cd445739 1308 ;;
7e365483 1309 OLD)
cd445739 1310 echo "Warning: This spec has old style bconds. Fix it || die."
fa4bf1df 1311 for opt in `echo "$bcond_avail" | grep ^_without_`
cd445739 1312 do
fa4bf1df
ER
1313 AVAIL_BCOND_WITHOUT=${opt#_without_}
1314 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
cd445739
AM
1315 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1316 else
1317 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1318 fi
1319 done
2a5f078d 1320
fa4bf1df 1321 for opt in `echo "$bcond_avail" | grep ^_with_`
cd445739 1322 do
fa4bf1df
ER
1323 AVAIL_BCOND_WITH=${opt#_with_}
1324 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
cd445739
AM
1325 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1326 else
1327 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1328 fi
1329 done
1330 ;;
1331 NEW)
fa4bf1df
ER
1332 local cond_type="" # with || without
1333 for opt in $bcond_avail; do
cd445739
AM
1334 case "$opt" in
1335 _without)
1336 cond_type="without"
1337 ;;
1338 _with)
1339 cond_type="with"
1340 ;;
f8d24cee 1341 _without_*)
fa4bf1df
ER
1342 AVAIL_BCOND_WITHOUT=${opt#_without_}
1343 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
f8d24cee 1344 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1345 else
1346 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1347 fi
1348 ;;
1349 _with_*)
fa4bf1df
ER
1350 AVAIL_BCOND_WITH=${opt#_with_}
1351 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
f8d24cee 1352 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1353 else
1354 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1355 fi
1356 ;;
cd445739
AM
1357 *)
1358 case "$cond_type" in
1359 with)
1360 cond_type=''
1361 AVAIL_BCOND_WITH="$opt"
fa4bf1df 1362 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
cd445739
AM
1363 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1364 else
1365 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1366 fi
7e365483 1367 ;;
cd445739
AM
1368 without)
1369 cond_type=''
1370 AVAIL_BCOND_WITHOUT="$opt"
fa4bf1df 1371 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
cd445739
AM
1372 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1373 else
1374 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1375 fi
1376 ;;
1377 esac
1378 ;;
1379 esac
1380 done
1381 ;;
1382 esac
1383}
1384
1385run_sub_builder()
1386{
1387 package_name="${1}"
af6b168f 1388 update_shell_title "run_sub_builder $package_name"
cd445739
AM
1389 #
1390